import java.awt.*;
import java.awt.event.*;
import java.lang.Math;
public class HouseholderRegression extends Frame
{  public double currentX, currentY; // ݂̕`ʒu
   public HouseholderRegression()
   {  setSize(600,600);
      addWindowListener(new WindowAdapter()
      { public void windowClosing(WindowEvent e){System.exit(0);}
      });
   }
   private double[] Householder(double [][]X, double[]Y, int M, int N)
  {  double [] B     = new double[M]; double [] U     = new double[N];
     int    [] IPV   = new int   [M]; double [] INorm = new double[M];
     double T; double MaxRNorm = -1; double MaxNormSq = 0 ; int Rank = 0;
     for(int k = 0; k < M; k++){ IPV[k] = k; INorm[k] = 1;}
     int DebugID=0;
     int ConditionNumber = M;
     for(int k = 0; k < M; k++)
     {  MaxRNorm = - 1; int MaxP = 0; int IK;
        for(int j = k; j < M; j++)
        { int IJ = IPV[j];
          if(INorm[IJ] > 0)
          { double S = 0; for(int i = k; i < N; i++) S += X[i][IJ] * X[i][IJ];
            if(k == 0) { INorm[IJ] = S; T = S;}
            else       T = S / INorm[IJ];
            if( T > MaxRNorm) { MaxRNorm = T; MaxNormSq = S; MaxP = j;}
          }
        }
        if(MaxRNorm >= 0) {IK = IPV[MaxP]; IPV[MaxP] = IPV[k]; IPV[k] = IK;}
        else              {Rank = k - 1; ConditionNumber = 0; break;}
        for(int i = k; i< N; i++)  U[i] = X[i][IK];
        double S = Math.sqrt(MaxNormSq); if(U[k] < 0) S = - S;
        U[k] = U[k] + S; X[k][IK] = - S;
        T = 1.0 / (U[k] * S);
        S  = 0; for(int i = k; i < N; i++)  S        += U[i] * Y[i];
        S *= T; for(int i = k; i < N; i++)  Y[i]     -= S    * U[i];
        for(int j = k + 1; j< M; j++)
        { int IJ = IPV[j];
          S  = 0; for(int i = k; i< N ; i++)  S        += U[i] * X[i][IJ];
          S *= T; for(int i = k; i< N ; i++)  X[i][IJ] -= S    * U[i];
        }
     }
     if(ConditionNumber != 0){ Rank = M; ConditionNumber = (int)(1 / Math.sqrt(MaxRNorm));}
     for(int k = Rank + 1; k < M; k++)  B[IPV[k]] = 0;
     for(int k = Rank-1    ; k >=0; k--)
     {  int IK = IPV[k]; double S = Y[k];
        for(int j = k + 1; j < Rank; j++)
        {
             int IJ = IPV[j]; S -= X[k][IJ] * B[IJ];
        }
        B[IK] = S / X[k][IK];
     }
    
     return B;
   }
   public int Xpos(double X)
   {  return (int)(X*30)+100;}
   public int Ypos(double Y)
   {  return 500- (int)(Y*2);}
   public void drawLine(Graphics g, double X1, double Y1, double X2, double Y2)
   {  g.drawLine(Xpos(X1),Ypos(Y1),Xpos(X2),Ypos(Y2));
   }
   public void drawPoint(Graphics g, double X, double Y)
   {  g.fillOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawCircle(Graphics g, double X, double Y)
   {  g.drawOval(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public void drawRect(Graphics g, double X, double Y)
   {  g.drawRect(Xpos(X)-2,Ypos(Y)-2,4,4);
   }
   public boolean Draw(Graphics g, double X, double Y, boolean Flag)
   {  if(Flag) drawLine(g, currentX, currentY, X, Y);
      currentX = X; currentY = Y;
      return true;
   }

   public void paint(Graphics g)
   { int Num = 10; int ND = 3; int NN = ND + 1;
     double [][] X = { {5,5,2},{ 6,4,3},{4,3,4},{2,2, 5},{5,4, 6},
                       {8,5,7},{10,6,8},{4,8,9},{7,2,10},{9,3,11}};
     double [][] X0 =new double[10][3];
     for(int i=0;i<10; i++) for(int j=0;j<3;j++) X0[i][j]=X[i][j];
     double [] Y = {55,40,30,25,45,70,90,25,45,75};
     setTitle("dAւ̃nEXz_@̓Kp");
     for(int i = 0; i< 13; i++) drawLine(g, i, 0,i,100);
     for(int i = 0; i<= 100; i += 5) drawLine(g, 0, i,12, i);
     g.setColor(new Color(  0,  0,  0));
     g.drawString("_mFpC̑̓f[^",100,280);
     boolean Flag = false;
     g.setColor(new Color(0,0,255));
     for(int i = 0; i< Num; i++)
     {   g.setColor(new Color(  0,  0,255)); drawPoint (g, X[i][0], Y[i]);
         g.setColor(new Color(  0,255,  0)); drawCircle(g, X[i][1], Y[i]);
         g.setColor(new Color(255,  0,  0)); drawRect  (g, X[i][2], Y[i]);
     }
    double [] B = Householder(X, Y, ND, 10);
    for(int i = 0; i< Num; i++)
    {    double YY=X0[i][0]*B[0]+X0[i][1]*B[1]+X0[i][2]*B[2];
         g.setColor(new Color(  0,  0,  0)); drawPoint (g, X0[i][0], YY);
     }
    for(int i = 0; i< ND; i++)g.drawString(" (" + i + ")" + B[i],400,100+20*i); 
    
  } 
   public static void main(String[] args)
   {  Frame w = new HouseholderRegression();
      w.setVisible(true);
   }
}
